igeo

## Class IVolume

- java.lang.Object
- - igeo.IObject
  - - igeo.IGeometry
    - - igeo.IVolume

- All Implemented Interfaces:
    IParameter, ITransformable, IVal, IVolumeI, IVolumeOp

      public class IVolume
      extends IGeometry
      implements IVolumeI

  Class of NURBS volume object. It contains IVolumeGeo instance inside.
  Author:
    Satoru Sugihara

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `IVolumeGeo` | `volume`

    - ### Fields inherited from class igeo.IObject

      `attribute, dynamics, graphics, parameter, server, userData`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IVolume()`
    `IVolume(double[][][][] xyzValues)`
    `IVolume(double[][][][] xyzValues, boolean closeU, boolean closeV, boolean closeW)`
    `IVolume(double[][][][] xyzValues, int udeg, int vdeg, int wdeg)`
    `IVolume(double[][][][] xyzValues, int udeg, int vdeg, int wdeg, boolean closeU, boolean closeV, boolean closeW)`
    `IVolume(double x111, double y111, double z111, double x211, double y211, double z211, double x121, double y121, double z121, double x221, double y221, double z221, double x112, double y112, double z112, double x212, double y212, double z212, double x122, double y122, double z122, double x222, double y222, double z222)`
    `IVolume(IServerI s)`
    `IVolume(IServerI s, double[][][][] xyzValues)`
    `IVolume(IServerI s, double[][][][] xyzValues, boolean closeU, boolean closeV, boolean closeW)`
    `IVolume(IServerI s, double[][][][] xyzValues, int udeg, int vdeg, int wdeg)`
    `IVolume(IServerI s, double[][][][] xyzValues, int udeg, int vdeg, int wdeg, boolean closeU, boolean closeV, boolean closeW)`
    `IVolume(IServerI s, double x111, double y111, double z111, double x211, double y211, double z211, double x121, double y121, double z121, double x221, double y221, double z221, double x112, double y112, double z112, double x212, double y212, double z212, double x122, double y122, double z122, double x222, double y222, double z222)`
    `IVolume(IServerI s, IVecI[][][] cpts)`
    `IVolume(IServerI s, IVecI[][][] cpts, boolean closeU, boolean closeV, boolean closeW)`
    `IVolume(IServerI s, IVecI[][][] cpts, int udegree, int vdegree, int wdegree)`
    `IVolume(IServerI s, IVecI[][][] cpts, int udegree, int vdegree, int wdegree, boolean closeU, boolean closeV, boolean closeW)`
    `IVolume(IServerI s, IVecI[][][] cpts, int udegree, int vdegree, int wdegree, boolean closeU, double[] vk, double[] wk)`
    `IVolume(IServerI s, IVecI[][][] cpts, int udegree, int vdegree, int wdegree, double[] uk, boolean closeV, double[] wk)`
    `IVolume(IServerI s, IVecI[][][] cpts, int udegree, int vdegree, int wdegree, double[] uk, double[] vk, boolean closeW)`
    `IVolume(IServerI s, IVecI[][][] cpts, int udegree, int vdegree, int wdegree, double[] uknots, double[] vknots, double[] wknots)`
    `IVolume(IServerI s, IVecI[][][] cpts, int udegree, int vdegree, int wdegree, double[] uknots, double[] vknots, double[] wknots, double ustart, double uend, double vstart, double vend, double wstart, double wend)`
    `IVolume(IServerI s, IVecI pt111, IVecI pt211, IVecI pt121, IVecI pt221, IVecI pt112, IVecI pt212, IVecI pt122, IVecI pt222)`
    `IVolume(IServerI s, IVolume vol)`
    `IVolume(IServerI s, IVolumeGeo vol)`
    `IVolume(IServerI s, IVolumeI vol)`
    `IVolume(IVecI[][][] cpts)`
    `IVolume(IVecI[][][] cpts, boolean closeU, boolean closeV, boolean closeW)`
    `IVolume(IVecI[][][] cpts, int udegree, int vdegree, int wdegree)`
    `IVolume(IVecI[][][] cpts, int udegree, int vdegree, int wdegree, boolean closeU, boolean closeV, boolean closeW)`
    `IVolume(IVecI[][][] cpts, int udegree, int vdegree, int wdegree, boolean closeU, double[] vk, double[] wk)`
    `IVolume(IVecI[][][] cpts, int udegree, int vdegree, int wdegree, double[] uk, boolean closeV, double[] wk)`
    `IVolume(IVecI[][][] cpts, int udegree, int vdegree, int wdegree, double[] uk, double[] vk, boolean closeW)`
    `IVolume(IVecI[][][] cpts, int udegree, int vdegree, int wdegree, double[] uknots, double[] vknots, double[] wknots)`
    `IVolume(IVecI[][][] cpts, int udegree, int vdegree, int wdegree, double[] uknots, double[] vknots, double[] wknots, double ustart, double uend, double vstart, double vend, double wstart, double wend)`
    `IVolume(IVecI pt111, IVecI pt211, IVecI pt121, IVecI pt221, IVecI pt112, IVecI pt212, IVecI pt122, IVecI pt222)`
    `IVolume(IVolume vol)`
    `IVolume(IVolumeGeo vol)`
    `IVolume(IVolumeI vol)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IVolume` | `add(double x, double y, double z)` transformation methods; API of ITransformable interface
    `IVolume` | `add(double f, IVecI v)` scale add alias
    `IVolume` | `add(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IVolume` | `add(IDoubleI f, IVecI v)` scale add alias
    `IVolume` | `add(IVecI v)`
    `IVolume` | `add(IVecI v, double f)` scale add
    `IVolume` | `add(IVecI v, IDoubleI f)` scale add
    `IVolume` | `attr(IAttribute at)` set attributes
    `IVec` | `center()` returns center of geometry object
    `IVolume` | `clr(java.awt.Color c)`
    `IVolume` | `clr(java.awt.Color c, double alpha)`
    `IVolume` | `clr(java.awt.Color c, float alpha)`
    `IVolume` | `clr(java.awt.Color c, int alpha)`
    `IVolume` | `clr(double dgray)`
    `IVolume` | `clr(double dgray, double dalpha)`
    `IVolume` | `clr(double dr, double dg, double db)`
    `IVolume` | `clr(double dr, double dg, double db, double da)`
    `IVolume` | `clr(float fgray)`
    `IVolume` | `clr(float fgray, float falpha)`
    `IVolume` | `clr(float fr, float fg, float fb)`
    `IVolume` | `clr(float fr, float fg, float fb, float fa)`
    `IVolume` | `clr(IColor c)` to set an object color
    `IVolume` | `clr(IColor c, double alpha)` to set color, with alpha value overwritten
    `IVolume` | `clr(IColor c, float alpha)` to set color, with alpha value overwritten
    `IVolume` | `clr(IColor c, int alpha)` to set color, with alpha value overwritten
    `IVolume` | `clr(int gray)`
    `IVolume` | `clr(int gray, int alpha)`
    `IVolume` | `clr(int r, int g, int b)`
    `IVolume` | `clr(int r, int g, int b, int a)`
    `IVolume` | `clr(IObject o)` to set the same color with the object
    `IVec` | `corner(IIntegerI i, IIntegerI j, IIntegerI k)`
    `IVec` | `corner(int i, int j, int k)`
    `IVecI` | `cornerCP(IIntegerI i, IIntegerI j, IIntegerI k)`
    `IVec` | `cornerCP(int i, int j, int k)`
    `IVolume` | `cp()` cp() is alias of dup()
    `IVolume` | `cp(double x, double y, double z)` cp() is alias of dup().add()
    `IVolume` | `cp(IDoubleI x, IDoubleI y, IDoubleI z)` cp() is alias of dup().add()
    `IVecI` | `cp(IIntegerI i, IIntegerI j, IIntegerI k)` getting control point at i, j, k
    `IVec` | `cp(int i, int j, int k)` getting control point at i, j, k
    `IVolume` | `cp(IVecI v)` cp() is alias of dup().add()
    `IVecI[][][]` | `cps()`
    `IGraphicObject` | `createGraphic(IGraphicMode m)`
    `IVolume` | `div(double v)`
    `IVolume` | `div(IDoubleI v)`
    `IVolume` | `dup()` duplicate object
    `IVec` | `ep(IIntegerI i, IIntegerI j, IIntegerI k)` getting edit point at i, j, k
    `IVec` | `ep(int i, int j, int k)` getting edit point at i, j, k
    `IVolume` | `flip()` alias of neg
    `IVolumeGeo` | `get()`
    `IVolume` | `hide()`
    `IVolume` | `hsb(double h, double s, double b)`
    `IVolume` | `hsb(double h, double s, double b, double a)`
    `IVolume` | `hsb(float h, float s, float b)`
    `IVolume` | `hsb(float h, float s, float b, float a)`
    `void` | `initVolume(IServerI s)`
    `boolean` | `isRational()`
    `boolean` | `isRational(ISwitchE e)`
    `IBool` | `isRational(ISwitchR r)`
    `boolean` | `isUClosed()` swap U and V parameter
    `boolean` | `isUClosed(ISwitchE e)`
    `IBool` | `isUClosed(ISwitchR r)`
    `boolean` | `isValid()` checking parameters validity.
    `boolean` | `isVClosed()`
    `boolean` | `isVClosed(ISwitchE e)`
    `IBool` | `isVClosed(ISwitchR r)`
    `boolean` | `isWClosed()`
    `boolean` | `isWClosed(ISwitchE e)`
    `IBool` | `isWClosed(ISwitchR r)`
    `IVolume` | `layer(ILayer l)` Set layer by ILayer object
    `IVolume` | `layer(java.lang.String l)` Set layer by layer name.
    `IVec` | `mid()` mid in UV parameter (u=0.5, v=0.5) point on a surface
    `IVolume` | `mirror(IVecI planeDir)` mirror is alias of ref
    `IVolume` | `mirror(IVecI center, IVecI planeDir)`
    `IVolume` | `mul(double v)`
    `IVolume` | `mul(IDoubleI v)`
    `IVolume` | `mv(double x, double y, double z)` mv() is alias of add()
    `IVolume` | `mv(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IVolume` | `mv(IVecI v)`
    `IVolume` | `name(java.lang.String nm)` methods of IObject
    `IVolume` | `neg()`
    `IVec` | `pt(double u, double v, double w)`
    `IVec` | `pt(IDoubleI u, IDoubleI v, IDoubleI w)`
    `IVec` | `pt(IVecI uvw)`
    `IVolume` | `ref(IVecI planeDir)` reflect(mirror) 3 dimensionally to the other side of the plane
    `IVolume` | `ref(IVecI center, IVecI planeDir)`
    `IVolume` | `rot(double angle)`
    `IVolume` | `rot(IDoubleI angle)` rotation around z-axis and origin
    `IVolume` | `rot(IVecI axis, double angle)`
    `IVolume` | `rot(IVecI axis, IDoubleI angle)` rotation around axis vector
    `IVolume` | `rot(IVecI axis, IVecI destDir)` rotate to destination direction vector
    `IVolume` | `rot(IVecI center, IVecI axis, double angle)`
    `IVolume` | `rot(IVecI center, IVecI axis, IDoubleI angle)` rotation around axis vector and center
    `IVolume` | `rot(IVecI center, IVecI axis, IVecI destPt)` rotate to destination point location
    `IVolume` | `rot2(double angle)` rotation on xy-plane around origin; same with rot(double)
    `IVolume` | `rot2(IDoubleI angle)` rotation on xy-plane around origin; same with rot(IDoubleI)
    `IVolume` | `rot2(IVecI destDir)` rotation on xy-plane to destination direction vector
    `IVolume` | `rot2(IVecI center, double angle)`
    `IVolume` | `rot2(IVecI center, IDoubleI angle)` rotation on xy-plane around center
    `IVolume` | `rot2(IVecI center, IVecI destPt)` rotation on xy-plane to destination point location
    `IVolume` | `scale(double f)`
    `IVolume` | `scale(IDoubleI f)` alias of mul
    `IVolume` | `scale(IVecI center, double f)`
    `IVolume` | `scale(IVecI center, IDoubleI f)`
    `IVolume` | `scale1d(IVecI axis, double f)` scale only in 1 direction
    `IVolume` | `scale1d(IVecI axis, IDoubleI f)`
    `IVolume` | `scale1d(IVecI center, IVecI axis, double f)`
    `IVolume` | `scale1d(IVecI center, IVecI axis, IDoubleI f)`
    `IVolume` | `setColor(java.awt.Color c)`
    `IVolume` | `setColor(java.awt.Color c, double alpha)`
    `IVolume` | `setColor(java.awt.Color c, float alpha)`
    `IVolume` | `setColor(java.awt.Color c, int alpha)`
    `IVolume` | `setColor(double dgray)`
    `IVolume` | `setColor(double dgray, double dalpha)`
    `IVolume` | `setColor(double dr, double dg, double db)`
    `IVolume` | `setColor(double dr, double dg, double db, double da)`
    `IVolume` | `setColor(float fgray)`
    `IVolume` | `setColor(float fgray, float falpha)`
    `IVolume` | `setColor(float fr, float fg, float fb)`
    `IVolume` | `setColor(float fr, float fg, float fb, float fa)`
    `IVolume` | `setColor(IColor c)`
    `IVolume` | `setColor(IColor c, double alpha)`
    `IVolume` | `setColor(IColor c, float alpha)`
    `IVolume` | `setColor(IColor c, int alpha)`
    `IVolume` | `setColor(int gray)`
    `IVolume` | `setColor(int gray, int alpha)`
    `IVolume` | `setColor(int r, int g, int b)`
    `IVolume` | `setColor(int r, int g, int b, int a)`
    `IVolume` | `setHSBColor(double h, double s, double b)`
    `IVolume` | `setHSBColor(double h, double s, double b, double a)`
    `IVolume` | `setHSBColor(float h, float s, float b)`
    `IVolume` | `setHSBColor(float h, float s, float b, float a)`
    `IVolume` | `shear(double sxy, double syx, double syz, double szy, double szx, double sxz)` shear operation
    `IVolume` | `shear(IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)`
    `IVolume` | `shear(IVecI center, double sxy, double syx, double syz, double szy, double szx, double sxz)`
    `IVolume` | `shear(IVecI center, IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)`
    `IVolume` | `shearXY(double sxy, double syx)`
    `IVolume` | `shearXY(IDoubleI sxy, IDoubleI syx)`
    `IVolume` | `shearXY(IVecI center, double sxy, double syx)`
    `IVolume` | `shearXY(IVecI center, IDoubleI sxy, IDoubleI syx)`
    `IVolume` | `shearYZ(double syz, double szy)`
    `IVolume` | `shearYZ(IDoubleI syz, IDoubleI szy)`
    `IVolume` | `shearYZ(IVecI center, double syz, double szy)`
    `IVolume` | `shearYZ(IVecI center, IDoubleI syz, IDoubleI szy)`
    `IVolume` | `shearZX(double szx, double sxz)`
    `IVolume` | `shearZX(IDoubleI szx, IDoubleI sxz)`
    `IVolume` | `shearZX(IVecI center, double szx, double sxz)`
    `IVolume` | `shearZX(IVecI center, IDoubleI szx, IDoubleI sxz)`
    `IVolume` | `show()`
    `IVolume` | `sub(double x, double y, double z)`
    `IVolume` | `sub(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IVolume` | `sub(IVecI v)`
    `IVolume` | `transform(IMatrix3I mat)`
    `IVolume` | `transform(IMatrix4I mat)`
    `IVolume` | `transform(IVecI xvec, IVecI yvec, IVecI zvec)`
    `IVolume` | `transform(IVecI xvec, IVecI yvec, IVecI zvec, IVecI translate)`
    `IVolume` | `translate(double x, double y, double z)` translate() is alias of add()
    `IVolume` | `translate(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IVolume` | `translate(IVecI v)`
    `IDouble` | `u(IIntegerI epIdx, IDoubleI epFraction)`
    `double` | `u(int epIdx, double epFraction)`
    `int` | `ucpNum()`
    `int` | `ucpNum(ISwitchE e)`
    `IInteger` | `ucpNum(ISwitchR r)`
    `int` | `udeg()`
    `int` | `udeg(ISwitchE e)`
    `IInteger` | `udeg(ISwitchR r)`
    `double` | `uend()`
    `double` | `uend(ISwitchE e)`
    `IDouble` | `uend(ISwitchR r)`
    `int` | `uepNum()`
    `int` | `uepNum(ISwitchE e)`
    `IInteger` | `uepNum(ISwitchR r)`
    `IDouble` | `uknot(IIntegerI i)`
    `double` | `uknot(int i)` distance to the closest point in the volume
    `int` | `uknotNum()`
    `int` | `uknotNum(ISwitchE e)`
    `IInteger` | `uknotNum(ISwitchR r)`
    `double[]` | `uknots()`
    `double[]` | `uknots(ISwitchE e)`
    `IDoubleI[]` | `uknots(ISwitchR r)`
    `int` | `unum()`
    `int` | `unum(ISwitchE e)`
    `IInteger` | `unum(ISwitchR r)`
    `double` | `ustart()` original knots start value and end value
    `double` | `ustart(ISwitchE e)`
    `IDouble` | `ustart(ISwitchR r)`
    `IVec` | `utan(double u, double v, double w)`
    `IVec` | `utan(IDoubleI u, IDoubleI v, IDoubleI w)`
    `IVec` | `utan(IVecI uvw)`
    `IDouble` | `v(IIntegerI epIdx, IDoubleI epFraction)`
    `double` | `v(int epIdx, double epFraction)`
    `int` | `vcpNum()`
    `int` | `vcpNum(ISwitchE e)`
    `IInteger` | `vcpNum(ISwitchR r)`
    `int` | `vdeg()`
    `int` | `vdeg(ISwitchE e)`
    `IInteger` | `vdeg(ISwitchR r)`
    `double` | `vend()`
    `double` | `vend(ISwitchE e)`
    `IDouble` | `vend(ISwitchR r)`
    `int` | `vepNum()`
    `int` | `vepNum(ISwitchE e)`
    `IInteger` | `vepNum(ISwitchR r)`
    `IDouble` | `vknot(IIntegerI i)`
    `double` | `vknot(int i)`
    `int` | `vknotNum()`
    `int` | `vknotNum(ISwitchE e)`
    `IInteger` | `vknotNum(ISwitchR r)`
    `double[]` | `vknots()`
    `double[]` | `vknots(ISwitchE e)`
    `IDoubleI[]` | `vknots(ISwitchR r)`
    `int` | `vnum()`
    `int` | `vnum(ISwitchE e)`
    `IInteger` | `vnum(ISwitchR r)`
    `double` | `vstart()`
    `double` | `vstart(ISwitchE e)`
    `IDouble` | `vstart(ISwitchR r)`
    `IVec` | `vtan(double u, double v, double w)`
    `IVec` | `vtan(IDoubleI u, IDoubleI v, IDoubleI w)`
    `IVec` | `vtan(IVecI uvw)`
    `IDouble` | `w(IIntegerI epIdx, IDoubleI epFraction)`
    `double` | `w(int epIdx, double epFraction)`
    `int` | `wcpNum()`
    `int` | `wcpNum(ISwitchE e)`
    `IInteger` | `wcpNum(ISwitchR r)`
    `int` | `wdeg()`
    `int` | `wdeg(ISwitchE e)`
    `IInteger` | `wdeg(ISwitchR r)`
    `IVolume` | `weight(double w)`
    `IVolume` | `weight(float w)`
    `double` | `wend()`
    `double` | `wend(ISwitchE e)`
    `IDouble` | `wend(ISwitchR r)`
    `int` | `wepNum()`
    `int` | `wepNum(ISwitchE e)`
    `IInteger` | `wepNum(ISwitchR r)`
    `IDouble` | `wknot(IIntegerI i)`
    `double` | `wknot(int i)`
    `int` | `wknotNum()`
    `int` | `wknotNum(ISwitchE e)`
    `IInteger` | `wknotNum(ISwitchR r)`
    `double[]` | `wknots()`
    `double[]` | `wknots(ISwitchE e)`
    `IDoubleI[]` | `wknots(ISwitchR r)`
    `int` | `wnum()`
    `int` | `wnum(ISwitchE e)`
    `IInteger` | `wnum(ISwitchR r)`
    `double` | `wstart()`
    `double` | `wstart(ISwitchE e)`
    `IDouble` | `wstart(ISwitchR r)`
    `IVec` | `wtan(double u, double v, double w)`
    `IVec` | `wtan(IDoubleI u, IDoubleI v, IDoubleI w)`
    `IVec` | `wtan(IVecI uvw)`

    - ### Methods inherited from class igeo.IObject

      `addDynamics, addUserData, addUserData, alpha, alphaInt, attr, attr, awtColor, blue, blueInt, brightness, castStringHashMap, clearDynamics, clearGraphics, clr, defaultAttribute, del, deletDynamics, deleteDynamics, deleteDynamics, deleteGraphic, dynamicsNum, getAWTColor, getColor, getDynamics, getGraphic, getGraphic, getParameter, graphicsNum, gray, grayInt, green, greenInt, grey, greyInt, hue, initGraphic, initObject, isVisible, layer, name, red, redInt, resetGraphic, saturation, server, setParameter, setTexture, syncColor, syncGraphic, syncVisibility, syncWeight, texture, updateGraphic, userData, userData, userData, userDataNum, visible, weight`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### volume

          public IVolumeGeo volume

  - ### Constructor Detail

    - #### IVolume

          public IVolume()

    - #### IVolume

          public IVolume(IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree,
                         double[] uknots,
                         double[] vknots,
                         double[] wknots,
                         double ustart,
                         double uend,
                         double vstart,
                         double vend,
                         double wstart,
                         double wend)

    - #### IVolume

          public IVolume(IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree,
                         double[] uknots,
                         double[] vknots,
                         double[] wknots)

    - #### IVolume

          public IVolume(IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree)

    - #### IVolume

          public IVolume(IVecI[][][] cpts)

    - #### IVolume

          public IVolume(IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree,
                         boolean closeU,
                         boolean closeV,
                         boolean closeW)

    - #### IVolume

          public IVolume(IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree,
                         boolean closeU,
                         double[] vk,
                         double[] wk)

    - #### IVolume

          public IVolume(IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree,
                         double[] uk,
                         boolean closeV,
                         double[] wk)

    - #### IVolume

          public IVolume(IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree,
                         double[] uk,
                         double[] vk,
                         boolean closeW)

    - #### IVolume

          public IVolume(IVecI[][][] cpts,
                         boolean closeU,
                         boolean closeV,
                         boolean closeW)

    - #### IVolume

          public IVolume(IVecI pt111,
                         IVecI pt211,
                         IVecI pt121,
                         IVecI pt221,
                         IVecI pt112,
                         IVecI pt212,
                         IVecI pt122,
                         IVecI pt222)

    - #### IVolume

          public IVolume(double x111,
                         double y111,
                         double z111,
                         double x211,
                         double y211,
                         double z211,
                         double x121,
                         double y121,
                         double z121,
                         double x221,
                         double y221,
                         double z221,
                         double x112,
                         double y112,
                         double z112,
                         double x212,
                         double y212,
                         double z212,
                         double x122,
                         double y122,
                         double z122,
                         double x222,
                         double y222,
                         double z222)

    - #### IVolume

          public IVolume(double[][][][] xyzValues)

    - #### IVolume

          public IVolume(double[][][][] xyzValues,
                         int udeg,
                         int vdeg,
                         int wdeg)

    - #### IVolume

          public IVolume(double[][][][] xyzValues,
                         boolean closeU,
                         boolean closeV,
                         boolean closeW)

    - #### IVolume

          public IVolume(double[][][][] xyzValues,
                         int udeg,
                         int vdeg,
                         int wdeg,
                         boolean closeU,
                         boolean closeV,
                         boolean closeW)

    - #### IVolume

          public IVolume(IVolumeGeo vol)

    - #### IVolume

          public IVolume(IVolumeI vol)

    - #### IVolume

          public IVolume(IServerI s)

    - #### IVolume

          public IVolume(IServerI s,
                         IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree,
                         double[] uknots,
                         double[] vknots,
                         double[] wknots,
                         double ustart,
                         double uend,
                         double vstart,
                         double vend,
                         double wstart,
                         double wend)

    - #### IVolume

          public IVolume(IServerI s,
                         IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree,
                         double[] uknots,
                         double[] vknots,
                         double[] wknots)

    - #### IVolume

          public IVolume(IServerI s,
                         IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree)

    - #### IVolume

          public IVolume(IServerI s,
                         IVecI[][][] cpts)

    - #### IVolume

          public IVolume(IServerI s,
                         IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree,
                         boolean closeU,
                         boolean closeV,
                         boolean closeW)

    - #### IVolume

          public IVolume(IServerI s,
                         IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree,
                         boolean closeU,
                         double[] vk,
                         double[] wk)

    - #### IVolume

          public IVolume(IServerI s,
                         IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree,
                         double[] uk,
                         boolean closeV,
                         double[] wk)

    - #### IVolume

          public IVolume(IServerI s,
                         IVecI[][][] cpts,
                         int udegree,
                         int vdegree,
                         int wdegree,
                         double[] uk,
                         double[] vk,
                         boolean closeW)

    - #### IVolume

          public IVolume(IServerI s,
                         IVecI[][][] cpts,
                         boolean closeU,
                         boolean closeV,
                         boolean closeW)

    - #### IVolume

          public IVolume(IServerI s,
                         IVecI pt111,
                         IVecI pt211,
                         IVecI pt121,
                         IVecI pt221,
                         IVecI pt112,
                         IVecI pt212,
                         IVecI pt122,
                         IVecI pt222)

    - #### IVolume

          public IVolume(IServerI s,
                         double x111,
                         double y111,
                         double z111,
                         double x211,
                         double y211,
                         double z211,
                         double x121,
                         double y121,
                         double z121,
                         double x221,
                         double y221,
                         double z221,
                         double x112,
                         double y112,
                         double z112,
                         double x212,
                         double y212,
                         double z212,
                         double x122,
                         double y122,
                         double z122,
                         double x222,
                         double y222,
                         double z222)

    - #### IVolume

          public IVolume(IServerI s,
                         double[][][][] xyzValues)

    - #### IVolume

          public IVolume(IServerI s,
                         double[][][][] xyzValues,
                         int udeg,
                         int vdeg,
                         int wdeg)

    - #### IVolume

          public IVolume(IServerI s,
                         double[][][][] xyzValues,
                         boolean closeU,
                         boolean closeV,
                         boolean closeW)

    - #### IVolume

          public IVolume(IServerI s,
                         double[][][][] xyzValues,
                         int udeg,
                         int vdeg,
                         int wdeg,
                         boolean closeU,
                         boolean closeV,
                         boolean closeW)

    - #### IVolume

          public IVolume(IServerI s,
                         IVolumeGeo vol)

    - #### IVolume

          public IVolume(IServerI s,
                         IVolumeI vol)

    - #### IVolume

          public IVolume(IVolume vol)

    - #### IVolume

          public IVolume(IServerI s,
                         IVolume vol)

  - ### Method Detail

    - #### initVolume

          public void initVolume(IServerI s)

    - #### createGraphic

          public IGraphicObject createGraphic(IGraphicMode m)

      Overrides:
        `createGraphic` in class `IObject`

    - #### isValid

          public boolean isValid()

      Description copied from class: `IObject`
      checking parameters validity. to be overriden.
      Specified by:
        `isValid` in interface `IVolumeI`
      Overrides:
        `isValid` in class `IObject`

    - #### get

          public IVolumeGeo get()

      Specified by:
        `get` in interface `IParameter`
      Specified by:
        `get` in interface `IVolumeI`
      Specified by:
        `get` in interface `IVolumeOp`
      Returns:
        fixed value but in wrapper class

    - #### dup

          public IVolume dup()

      Description copied from class: `IObject`
      duplicate object
      Specified by:
        `dup` in interface `ITransformable`
      Specified by:
        `dup` in interface `IVolumeI`
      Overrides:
        `dup` in class `IGeometry`
      Returns:
        duplicated instance

    - #### pt

          public IVec pt(double u,
                         double v,
                         double w)

      Specified by:
        `pt` in interface `IVolumeI`
      Parameters:
        `u` - u coordinates in uvw parameter space
        `v` - v coordinates in uvw parameter space
        `w` - w coordinates in uvw parameter space

    - #### pt

          public IVec pt(IDoubleI u,
                         IDoubleI v,
                         IDoubleI w)

      Specified by:
        `pt` in interface `IVolumeI`

    - #### pt

          public IVec pt(IVecI uvw)

      Specified by:
        `pt` in interface `IVolumeI`

    - #### utan

          public IVec utan(double u,
                           double v,
                           double w)

      Specified by:
        `utan` in interface `IVolumeI`

    - #### utan

          public IVec utan(IDoubleI u,
                           IDoubleI v,
                           IDoubleI w)

      Specified by:
        `utan` in interface `IVolumeI`

    - #### utan

          public IVec utan(IVecI uvw)

      Specified by:
        `utan` in interface `IVolumeI`

    - #### vtan

          public IVec vtan(double u,
                           double v,
                           double w)

      Specified by:
        `vtan` in interface `IVolumeI`

    - #### vtan

          public IVec vtan(IDoubleI u,
                           IDoubleI v,
                           IDoubleI w)

      Specified by:
        `vtan` in interface `IVolumeI`

    - #### vtan

          public IVec vtan(IVecI uvw)

      Specified by:
        `vtan` in interface `IVolumeI`

    - #### wtan

          public IVec wtan(double u,
                           double v,
                           double w)

      Specified by:
        `wtan` in interface `IVolumeI`

    - #### wtan

          public IVec wtan(IDoubleI u,
                           IDoubleI v,
                           IDoubleI w)

      Specified by:
        `wtan` in interface `IVolumeI`

    - #### wtan

          public IVec wtan(IVecI uvw)

      Specified by:
        `wtan` in interface `IVolumeI`

    - #### cp

          public IVec cp(int i,
                         int j,
                         int k)

      getting control point at i, j, k
      Specified by:
        `cp` in interface `IVolumeI`

    - #### cp

          public IVecI cp(IIntegerI i,
                          IIntegerI j,
                          IIntegerI k)

      getting control point at i, j, k
      Specified by:
        `cp` in interface `IVolumeI`

    - #### cps

          public IVecI[][][] cps()

      Specified by:
        `cps` in interface `IVolumeI`

    - #### ep

          public IVec ep(int i,
                         int j,
                         int k)

      getting edit point at i, j, k
      Specified by:
        `ep` in interface `IVolumeI`

    - #### ep

          public IVec ep(IIntegerI i,
                         IIntegerI j,
                         IIntegerI k)

      getting edit point at i, j, k
      Specified by:
        `ep` in interface `IVolumeI`

    - #### corner

          public IVec corner(int i,
                             int j,
                             int k)

      Specified by:
        `corner` in interface `IVolumeI`

    - #### corner

          public IVec corner(IIntegerI i,
                             IIntegerI j,
                             IIntegerI k)

      Specified by:
        `corner` in interface `IVolumeI`

    - #### cornerCP

          public IVec cornerCP(int i,
                               int j,
                               int k)

      Specified by:
        `cornerCP` in interface `IVolumeI`

    - #### cornerCP

          public IVecI cornerCP(IIntegerI i,
                                IIntegerI j,
                                IIntegerI k)

      Specified by:
        `cornerCP` in interface `IVolumeI`

    - #### mid

          public IVec mid()

      mid in UV parameter (u=0.5, v=0.5) point on a surface
      Specified by:
        `mid` in interface `IVolumeI`

    - #### center

          public IVec center()

      returns center of geometry object
      Specified by:
        `center` in interface `IVolumeI`
      Specified by:
        `center` in class `IGeometry`

    - #### uknot

          public double uknot(int i)

      Description copied from interface: `IVolumeI`
      distance to the closest point in the volume
      Specified by:
        `uknot` in interface `IVolumeI`

    - #### uknot

          public IDouble uknot(IIntegerI i)

      Specified by:
        `uknot` in interface `IVolumeI`

    - #### vknot

          public double vknot(int i)

      Specified by:
        `vknot` in interface `IVolumeI`

    - #### vknot

          public IDouble vknot(IIntegerI i)

      Specified by:
        `vknot` in interface `IVolumeI`

    - #### wknot

          public double wknot(int i)

      Specified by:
        `wknot` in interface `IVolumeI`

    - #### wknot

          public IDouble wknot(IIntegerI i)

      Specified by:
        `wknot` in interface `IVolumeI`

    - #### uknots

          public double[] uknots()

      Specified by:
        `uknots` in interface `IVolumeI`

    - #### vknots

          public double[] vknots()

      Specified by:
        `vknots` in interface `IVolumeI`

    - #### wknots

          public double[] wknots()

      Specified by:
        `wknots` in interface `IVolumeI`

    - #### uknots

          public double[] uknots(ISwitchE e)

      Specified by:
        `uknots` in interface `IVolumeI`

    - #### vknots

          public double[] vknots(ISwitchE e)

      Specified by:
        `vknots` in interface `IVolumeI`

    - #### wknots

          public double[] wknots(ISwitchE e)

      Specified by:
        `wknots` in interface `IVolumeI`

    - #### uknots

          public IDoubleI[] uknots(ISwitchR r)

      Specified by:
        `uknots` in interface `IVolumeI`

    - #### vknots

          public IDoubleI[] vknots(ISwitchR r)

      Specified by:
        `vknots` in interface `IVolumeI`

    - #### wknots

          public IDoubleI[] wknots(ISwitchR r)

      Specified by:
        `wknots` in interface `IVolumeI`

    - #### uknotNum

          public int uknotNum()

      Specified by:
        `uknotNum` in interface `IVolumeI`

    - #### vknotNum

          public int vknotNum()

      Specified by:
        `vknotNum` in interface `IVolumeI`

    - #### wknotNum

          public int wknotNum()

      Specified by:
        `wknotNum` in interface `IVolumeI`

    - #### uknotNum

          public int uknotNum(ISwitchE e)

      Specified by:
        `uknotNum` in interface `IVolumeI`

    - #### vknotNum

          public int vknotNum(ISwitchE e)

      Specified by:
        `vknotNum` in interface `IVolumeI`

    - #### wknotNum

          public int wknotNum(ISwitchE e)

      Specified by:
        `wknotNum` in interface `IVolumeI`

    - #### uknotNum

          public IInteger uknotNum(ISwitchR r)

      Specified by:
        `uknotNum` in interface `IVolumeI`

    - #### vknotNum

          public IInteger vknotNum(ISwitchR r)

      Specified by:
        `vknotNum` in interface `IVolumeI`

    - #### wknotNum

          public IInteger wknotNum(ISwitchR r)

      Specified by:
        `wknotNum` in interface `IVolumeI`

    - #### isRational

          public boolean isRational()

      Specified by:
        `isRational` in interface `IVolumeI`
      Returns:
        returns true if any of control point has non-default(1.0) weight otherwise false.

    - #### isRational

          public boolean isRational(ISwitchE e)

      Specified by:
        `isRational` in interface `IVolumeI`

    - #### isRational

          public IBool isRational(ISwitchR r)

      Specified by:
        `isRational` in interface `IVolumeI`

    - #### udeg

          public int udeg()

      Specified by:
        `udeg` in interface `IVolumeI`

    - #### vdeg

          public int vdeg()

      Specified by:
        `vdeg` in interface `IVolumeI`

    - #### wdeg

          public int wdeg()

      Specified by:
        `wdeg` in interface `IVolumeI`

    - #### udeg

          public int udeg(ISwitchE e)

      Specified by:
        `udeg` in interface `IVolumeI`

    - #### vdeg

          public int vdeg(ISwitchE e)

      Specified by:
        `vdeg` in interface `IVolumeI`

    - #### wdeg

          public int wdeg(ISwitchE e)

      Specified by:
        `wdeg` in interface `IVolumeI`

    - #### udeg

          public IInteger udeg(ISwitchR r)

      Specified by:
        `udeg` in interface `IVolumeI`

    - #### vdeg

          public IInteger vdeg(ISwitchR r)

      Specified by:
        `vdeg` in interface `IVolumeI`

    - #### wdeg

          public IInteger wdeg(ISwitchR r)

      Specified by:
        `wdeg` in interface `IVolumeI`

    - #### unum

          public int unum()

      Specified by:
        `unum` in interface `IVolumeI`

    - #### vnum

          public int vnum()

      Specified by:
        `vnum` in interface `IVolumeI`

    - #### wnum

          public int wnum()

      Specified by:
        `wnum` in interface `IVolumeI`

    - #### unum

          public int unum(ISwitchE e)

      Specified by:
        `unum` in interface `IVolumeI`

    - #### vnum

          public int vnum(ISwitchE e)

      Specified by:
        `vnum` in interface `IVolumeI`

    - #### wnum

          public int wnum(ISwitchE e)

      Specified by:
        `wnum` in interface `IVolumeI`

    - #### unum

          public IInteger unum(ISwitchR r)

      Specified by:
        `unum` in interface `IVolumeI`

    - #### vnum

          public IInteger vnum(ISwitchR r)

      Specified by:
        `vnum` in interface `IVolumeI`

    - #### wnum

          public IInteger wnum(ISwitchR r)

      Specified by:
        `wnum` in interface `IVolumeI`

    - #### ucpNum

          public int ucpNum()

      Specified by:
        `ucpNum` in interface `IVolumeI`

    - #### vcpNum

          public int vcpNum()

      Specified by:
        `vcpNum` in interface `IVolumeI`

    - #### wcpNum

          public int wcpNum()

      Specified by:
        `wcpNum` in interface `IVolumeI`

    - #### ucpNum

          public int ucpNum(ISwitchE e)

      Specified by:
        `ucpNum` in interface `IVolumeI`

    - #### vcpNum

          public int vcpNum(ISwitchE e)

      Specified by:
        `vcpNum` in interface `IVolumeI`

    - #### wcpNum

          public int wcpNum(ISwitchE e)

      Specified by:
        `wcpNum` in interface `IVolumeI`

    - #### ucpNum

          public IInteger ucpNum(ISwitchR r)

      Specified by:
        `ucpNum` in interface `IVolumeI`

    - #### vcpNum

          public IInteger vcpNum(ISwitchR r)

      Specified by:
        `vcpNum` in interface `IVolumeI`

    - #### wcpNum

          public IInteger wcpNum(ISwitchR r)

      Specified by:
        `wcpNum` in interface `IVolumeI`

    - #### uepNum

          public int uepNum()

      Specified by:
        `uepNum` in interface `IVolumeI`

    - #### vepNum

          public int vepNum()

      Specified by:
        `vepNum` in interface `IVolumeI`

    - #### wepNum

          public int wepNum()

      Specified by:
        `wepNum` in interface `IVolumeI`

    - #### uepNum

          public int uepNum(ISwitchE e)

      Specified by:
        `uepNum` in interface `IVolumeI`

    - #### vepNum

          public int vepNum(ISwitchE e)

      Specified by:
        `vepNum` in interface `IVolumeI`

    - #### wepNum

          public int wepNum(ISwitchE e)

      Specified by:
        `wepNum` in interface `IVolumeI`

    - #### uepNum

          public IInteger uepNum(ISwitchR r)

      Specified by:
        `uepNum` in interface `IVolumeI`

    - #### vepNum

          public IInteger vepNum(ISwitchR r)

      Specified by:
        `vepNum` in interface `IVolumeI`

    - #### wepNum

          public IInteger wepNum(ISwitchR r)

      Specified by:
        `wepNum` in interface `IVolumeI`

    - #### u

          public double u(int epIdx,
                          double epFraction)

      Specified by:
        `u` in interface `IVolumeI`

    - #### u

          public IDouble u(IIntegerI epIdx,
                           IDoubleI epFraction)

      Specified by:
        `u` in interface `IVolumeI`

    - #### v

          public double v(int epIdx,
                          double epFraction)

      Specified by:
        `v` in interface `IVolumeI`

    - #### v

          public IDouble v(IIntegerI epIdx,
                           IDoubleI epFraction)

      Specified by:
        `v` in interface `IVolumeI`

    - #### w

          public double w(int epIdx,
                          double epFraction)

      Specified by:
        `w` in interface `IVolumeI`

    - #### w

          public IDouble w(IIntegerI epIdx,
                           IDoubleI epFraction)

      Specified by:
        `w` in interface `IVolumeI`

    - #### ustart

          public double ustart()

      Description copied from interface: `IVolumeI`
      original knots start value and end value
      Specified by:
        `ustart` in interface `IVolumeI`

    - #### uend

          public double uend()

      Specified by:
        `uend` in interface `IVolumeI`

    - #### vstart

          public double vstart()

      Specified by:
        `vstart` in interface `IVolumeI`

    - #### vend

          public double vend()

      Specified by:
        `vend` in interface `IVolumeI`

    - #### wstart

          public double wstart()

      Specified by:
        `wstart` in interface `IVolumeI`

    - #### wend

          public double wend()

      Specified by:
        `wend` in interface `IVolumeI`

    - #### ustart

          public double ustart(ISwitchE e)

      Specified by:
        `ustart` in interface `IVolumeI`

    - #### uend

          public double uend(ISwitchE e)

      Specified by:
        `uend` in interface `IVolumeI`

    - #### vstart

          public double vstart(ISwitchE e)

      Specified by:
        `vstart` in interface `IVolumeI`

    - #### vend

          public double vend(ISwitchE e)

      Specified by:
        `vend` in interface `IVolumeI`

    - #### wstart

          public double wstart(ISwitchE e)

      Specified by:
        `wstart` in interface `IVolumeI`

    - #### wend

          public double wend(ISwitchE e)

      Specified by:
        `wend` in interface `IVolumeI`

    - #### ustart

          public IDouble ustart(ISwitchR r)

      Specified by:
        `ustart` in interface `IVolumeI`

    - #### uend

          public IDouble uend(ISwitchR r)

      Specified by:
        `uend` in interface `IVolumeI`

    - #### vstart

          public IDouble vstart(ISwitchR r)

      Specified by:
        `vstart` in interface `IVolumeI`

    - #### vend

          public IDouble vend(ISwitchR r)

      Specified by:
        `vend` in interface `IVolumeI`

    - #### wstart

          public IDouble wstart(ISwitchR r)

      Specified by:
        `wstart` in interface `IVolumeI`

    - #### wend

          public IDouble wend(ISwitchR r)

      Specified by:
        `wend` in interface `IVolumeI`

    - #### isUClosed

          public boolean isUClosed()

      Description copied from interface: `IVolumeI`
      swap U and V parameter
      Specified by:
        `isUClosed` in interface `IVolumeI`

    - #### isUClosed

          public boolean isUClosed(ISwitchE e)

      Specified by:
        `isUClosed` in interface `IVolumeI`

    - #### isUClosed

          public IBool isUClosed(ISwitchR r)

      Specified by:
        `isUClosed` in interface `IVolumeI`

    - #### isVClosed

          public boolean isVClosed()

      Specified by:
        `isVClosed` in interface `IVolumeI`

    - #### isVClosed

          public boolean isVClosed(ISwitchE e)

      Specified by:
        `isVClosed` in interface `IVolumeI`

    - #### isVClosed

          public IBool isVClosed(ISwitchR r)

      Specified by:
        `isVClosed` in interface `IVolumeI`

    - #### isWClosed

          public boolean isWClosed()

      Specified by:
        `isWClosed` in interface `IVolumeI`

    - #### isWClosed

          public boolean isWClosed(ISwitchE e)

      Specified by:
        `isWClosed` in interface `IVolumeI`

    - #### isWClosed

          public IBool isWClosed(ISwitchR r)

      Specified by:
        `isWClosed` in interface `IVolumeI`

    - #### add

          public IVolume add(double x,
                             double y,
                             double z)

      transformation methods; API of ITransformable interface
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVolumeI`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IVolume add(IDoubleI x,
                             IDoubleI y,
                             IDoubleI z)

      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVolumeI`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IVolume add(IVecI v)

      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVolumeI`
      Specified by:
        `add` in class `IGeometry`

    - #### sub

          public IVolume sub(double x,
                             double y,
                             double z)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in interface `IVolumeI`
      Specified by:
        `sub` in class `IGeometry`

    - #### sub

          public IVolume sub(IDoubleI x,
                             IDoubleI y,
                             IDoubleI z)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in interface `IVolumeI`
      Specified by:
        `sub` in class `IGeometry`

    - #### sub

          public IVolume sub(IVecI v)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in interface `IVolumeI`
      Specified by:
        `sub` in class `IGeometry`

    - #### mul

          public IVolume mul(IDoubleI v)

      Specified by:
        `mul` in interface `ITransformable`
      Specified by:
        `mul` in interface `IVolumeI`
      Specified by:
        `mul` in class `IGeometry`

    - #### mul

          public IVolume mul(double v)

      Specified by:
        `mul` in interface `ITransformable`
      Specified by:
        `mul` in interface `IVolumeI`
      Specified by:
        `mul` in class `IGeometry`

    - #### div

          public IVolume div(IDoubleI v)

      Specified by:
        `div` in interface `ITransformable`
      Specified by:
        `div` in interface `IVolumeI`
      Specified by:
        `div` in class `IGeometry`

    - #### div

          public IVolume div(double v)

      Specified by:
        `div` in interface `ITransformable`
      Specified by:
        `div` in interface `IVolumeI`
      Specified by:
        `div` in class `IGeometry`

    - #### neg

          public IVolume neg()

      Specified by:
        `neg` in interface `ITransformable`
      Specified by:
        `neg` in interface `IVolumeI`
      Specified by:
        `neg` in class `IGeometry`

    - #### flip

          public IVolume flip()

      alias of neg
      Specified by:
        `flip` in interface `ITransformable`
      Specified by:
        `flip` in interface `IVolumeI`
      Specified by:
        `flip` in class `IGeometry`

    - #### add

          public IVolume add(IVecI v,
                             double f)

      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVolumeI`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IVolume add(IVecI v,
                             IDoubleI f)

      Description copied from class: `IGeometry`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in interface `IVolumeI`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IVolume add(double f,
                             IVecI v)

      scale add alias
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IVolume add(IDoubleI f,
                             IVecI v)

      Description copied from class: `IGeometry`
      scale add alias
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### rot

          public IVolume rot(IDoubleI angle)

      Description copied from class: `IGeometry`
      rotation around z-axis and origin
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IVolume rot(double angle)

      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IVolume rot(IVecI axis,
                             IDoubleI angle)

      Description copied from class: `IGeometry`
      rotation around axis vector
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVolumeI`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IVolume rot(IVecI axis,
                             double angle)

      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVolumeI`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IVolume rot(IVecI center,
                             IVecI axis,
                             IDoubleI angle)

      Description copied from class: `IGeometry`
      rotation around axis vector and center
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVolumeI`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IVolume rot(IVecI center,
                             IVecI axis,
                             double angle)

      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVolumeI`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IVolume rot(IVecI axis,
                             IVecI destDir)

      rotate to destination direction vector
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVolumeI`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IVolume rot(IVecI center,
                             IVecI axis,
                             IVecI destPt)

      rotate to destination point location
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in interface `IVolumeI`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot2

          public IVolume rot2(IDoubleI angle)

      Description copied from class: `IGeometry`
      rotation on xy-plane around origin; same with rot(IDoubleI)
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IVolume rot2(double angle)

      Description copied from class: `IGeometry`
      rotation on xy-plane around origin; same with rot(double)
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IVolume rot2(IVecI center,
                              IDoubleI angle)

      Description copied from class: `IGeometry`
      rotation on xy-plane around center
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IVolume rot2(IVecI center,
                              double angle)

      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IVolume rot2(IVecI destDir)

      rotation on xy-plane to destination direction vector
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IVolume rot2(IVecI center,
                              IVecI destPt)

      rotation on xy-plane to destination point location
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### scale

          public IVolume scale(IDoubleI f)

      alias of mul
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVolumeI`
      Specified by:
        `scale` in class `IGeometry`

    - #### scale

          public IVolume scale(double f)

      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVolumeI`
      Specified by:
        `scale` in class `IGeometry`

    - #### scale

          public IVolume scale(IVecI center,
                               IDoubleI f)

      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVolumeI`
      Specified by:
        `scale` in class `IGeometry`

    - #### scale

          public IVolume scale(IVecI center,
                               double f)

      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in interface `IVolumeI`
      Specified by:
        `scale` in class `IGeometry`

    - #### scale1d

          public IVolume scale1d(IVecI axis,
                                 double f)

      scale only in 1 direction
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVolumeI`
      Specified by:
        `scale1d` in class `IGeometry`

    - #### scale1d

          public IVolume scale1d(IVecI axis,
                                 IDoubleI f)

      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVolumeI`
      Specified by:
        `scale1d` in class `IGeometry`

    - #### scale1d

          public IVolume scale1d(IVecI center,
                                 IVecI axis,
                                 double f)

      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVolumeI`
      Specified by:
        `scale1d` in class `IGeometry`

    - #### scale1d

          public IVolume scale1d(IVecI center,
                                 IVecI axis,
                                 IDoubleI f)

      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in interface `IVolumeI`
      Specified by:
        `scale1d` in class `IGeometry`

    - #### ref

          public IVolume ref(IVecI planeDir)

      reflect(mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `ITransformable`
      Specified by:
        `ref` in interface `IVolumeI`
      Specified by:
        `ref` in class `IGeometry`

    - #### ref

          public IVolume ref(IVecI center,
                             IVecI planeDir)

      Specified by:
        `ref` in interface `ITransformable`
      Specified by:
        `ref` in interface `IVolumeI`
      Specified by:
        `ref` in class `IGeometry`

    - #### mirror

          public IVolume mirror(IVecI planeDir)

      mirror is alias of ref
      Specified by:
        `mirror` in interface `ITransformable`
      Specified by:
        `mirror` in interface `IVolumeI`
      Specified by:
        `mirror` in class `IGeometry`

    - #### mirror

          public IVolume mirror(IVecI center,
                                IVecI planeDir)

      Specified by:
        `mirror` in interface `ITransformable`
      Specified by:
        `mirror` in interface `IVolumeI`
      Specified by:
        `mirror` in class `IGeometry`

    - #### shear

          public IVolume shear(double sxy,
                               double syx,
                               double syz,
                               double szy,
                               double szx,
                               double sxz)

      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVolumeI`
      Specified by:
        `shear` in class `IGeometry`

    - #### shear

          public IVolume shear(IDoubleI sxy,
                               IDoubleI syx,
                               IDoubleI syz,
                               IDoubleI szy,
                               IDoubleI szx,
                               IDoubleI sxz)

      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVolumeI`
      Specified by:
        `shear` in class `IGeometry`

    - #### shear

          public IVolume shear(IVecI center,
                               double sxy,
                               double syx,
                               double syz,
                               double szy,
                               double szx,
                               double sxz)

      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVolumeI`
      Specified by:
        `shear` in class `IGeometry`

    - #### shear

          public IVolume shear(IVecI center,
                               IDoubleI sxy,
                               IDoubleI syx,
                               IDoubleI syz,
                               IDoubleI szy,
                               IDoubleI szx,
                               IDoubleI sxz)

      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in interface `IVolumeI`
      Specified by:
        `shear` in class `IGeometry`

    - #### shearXY

          public IVolume shearXY(double sxy,
                                 double syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVolumeI`
      Specified by:
        `shearXY` in class `IGeometry`

    - #### shearXY

          public IVolume shearXY(IDoubleI sxy,
                                 IDoubleI syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVolumeI`
      Specified by:
        `shearXY` in class `IGeometry`

    - #### shearXY

          public IVolume shearXY(IVecI center,
                                 double sxy,
                                 double syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVolumeI`
      Specified by:
        `shearXY` in class `IGeometry`

    - #### shearXY

          public IVolume shearXY(IVecI center,
                                 IDoubleI sxy,
                                 IDoubleI syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in interface `IVolumeI`
      Specified by:
        `shearXY` in class `IGeometry`

    - #### shearYZ

          public IVolume shearYZ(double syz,
                                 double szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVolumeI`
      Specified by:
        `shearYZ` in class `IGeometry`

    - #### shearYZ

          public IVolume shearYZ(IDoubleI syz,
                                 IDoubleI szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVolumeI`
      Specified by:
        `shearYZ` in class `IGeometry`

    - #### shearYZ

          public IVolume shearYZ(IVecI center,
                                 double syz,
                                 double szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVolumeI`
      Specified by:
        `shearYZ` in class `IGeometry`

    - #### shearYZ

          public IVolume shearYZ(IVecI center,
                                 IDoubleI syz,
                                 IDoubleI szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in interface `IVolumeI`
      Specified by:
        `shearYZ` in class `IGeometry`

    - #### shearZX

          public IVolume shearZX(double szx,
                                 double sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVolumeI`
      Specified by:
        `shearZX` in class `IGeometry`

    - #### shearZX

          public IVolume shearZX(IDoubleI szx,
                                 IDoubleI sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVolumeI`
      Specified by:
        `shearZX` in class `IGeometry`

    - #### shearZX

          public IVolume shearZX(IVecI center,
                                 double szx,
                                 double sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVolumeI`
      Specified by:
        `shearZX` in class `IGeometry`

    - #### shearZX

          public IVolume shearZX(IVecI center,
                                 IDoubleI szx,
                                 IDoubleI sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in interface `IVolumeI`
      Specified by:
        `shearZX` in class `IGeometry`

    - #### mv

          public IVolume mv(double x,
                            double y,
                            double z)

      mv() is alias of add()
      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in interface `IVolumeI`
      Specified by:
        `mv` in class `IGeometry`

    - #### mv

          public IVolume mv(IDoubleI x,
                            IDoubleI y,
                            IDoubleI z)

      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in interface `IVolumeI`
      Specified by:
        `mv` in class `IGeometry`

    - #### mv

          public IVolume mv(IVecI v)

      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in interface `IVolumeI`
      Specified by:
        `mv` in class `IGeometry`

    - #### cp

          public IVolume cp()

      cp() is alias of dup()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVolumeI`
      Overrides:
        `cp` in class `IGeometry`

    - #### cp

          public IVolume cp(double x,
                            double y,
                            double z)

      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVolumeI`
      Specified by:
        `cp` in class `IGeometry`

    - #### cp

          public IVolume cp(IDoubleI x,
                            IDoubleI y,
                            IDoubleI z)

      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVolumeI`
      Specified by:
        `cp` in class `IGeometry`

    - #### cp

          public IVolume cp(IVecI v)

      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in interface `IVolumeI`
      Specified by:
        `cp` in class `IGeometry`

    - #### translate

          public IVolume translate(double x,
                                   double y,
                                   double z)

      translate() is alias of add()
      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in interface `IVolumeI`
      Specified by:
        `translate` in class `IGeometry`

    - #### translate

          public IVolume translate(IDoubleI x,
                                   IDoubleI y,
                                   IDoubleI z)

      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in interface `IVolumeI`
      Specified by:
        `translate` in class `IGeometry`

    - #### translate

          public IVolume translate(IVecI v)

      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in interface `IVolumeI`
      Specified by:
        `translate` in class `IGeometry`

    - #### transform

          public IVolume transform(IMatrix3I mat)

      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVolumeI`
      Specified by:
        `transform` in class `IGeometry`

    - #### transform

          public IVolume transform(IMatrix4I mat)

      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVolumeI`
      Specified by:
        `transform` in class `IGeometry`

    - #### transform

          public IVolume transform(IVecI xvec,
                                   IVecI yvec,
                                   IVecI zvec)

      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVolumeI`
      Specified by:
        `transform` in class `IGeometry`

    - #### transform

          public IVolume transform(IVecI xvec,
                                   IVecI yvec,
                                   IVecI zvec,
                                   IVecI translate)

      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in interface `IVolumeI`
      Specified by:
        `transform` in class `IGeometry`

    - #### name

          public IVolume name(java.lang.String nm)

      methods of IObject
      Overrides:
        `name` in class `IObject`

    - #### layer

          public IVolume layer(ILayer l)

      Description copied from class: `IGeometry`
      Set layer by ILayer object
      Overrides:
        `layer` in class `IGeometry`

    - #### layer

          public IVolume layer(java.lang.String l)

      Description copied from class: `IGeometry`
      Set layer by layer name. If the layer specified by the name is not existing in the server, a new layer is automatically created in the server
      Overrides:
        `layer` in class `IGeometry`

    - #### attr

          public IVolume attr(IAttribute at)

      Description copied from class: `IObject`
      set attributes
      Overrides:
        `attr` in class `IGeometry`

    - #### hide

          public IVolume hide()

      Overrides:
        `hide` in class `IGeometry`

    - #### show

          public IVolume show()

      Overrides:
        `show` in class `IGeometry`

    - #### clr

          public IVolume clr(IColor c)

      Description copied from class: `IObject`
      to set an object color
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(IColor c,
                             int alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(IColor c,
                             float alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(IColor c,
                             double alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(IObject o)

      Description copied from class: `IObject`
      to set the same color with the object
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(java.awt.Color c)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(java.awt.Color c,
                             int alpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(java.awt.Color c,
                             float alpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(java.awt.Color c,
                             double alpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(int gray)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(float fgray)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(double dgray)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(int gray,
                             int alpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(float fgray,
                             float falpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(double dgray,
                             double dalpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(int r,
                             int g,
                             int b)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(float fr,
                             float fg,
                             float fb)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(double dr,
                             double dg,
                             double db)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(int r,
                             int g,
                             int b,
                             int a)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(float fr,
                             float fg,
                             float fb,
                             float fa)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IVolume clr(double dr,
                             double dg,
                             double db,
                             double da)

      Overrides:
        `clr` in class `IGeometry`

    - #### hsb

          public IVolume hsb(float h,
                             float s,
                             float b,
                             float a)

      Overrides:
        `hsb` in class `IGeometry`

    - #### hsb

          public IVolume hsb(double h,
                             double s,
                             double b,
                             double a)

      Overrides:
        `hsb` in class `IGeometry`

    - #### hsb

          public IVolume hsb(float h,
                             float s,
                             float b)

      Overrides:
        `hsb` in class `IGeometry`

    - #### hsb

          public IVolume hsb(double h,
                             double s,
                             double b)

      Overrides:
        `hsb` in class `IGeometry`

    - #### setColor

          public IVolume setColor(IColor c)

      Overrides:
        `setColor` in class `IObject`

    - #### setColor

          public IVolume setColor(IColor c,
                                  int alpha)

      Overrides:
        `setColor` in class `IObject`

    - #### setColor

          public IVolume setColor(IColor c,
                                  float alpha)

      Overrides:
        `setColor` in class `IObject`

    - #### setColor

          public IVolume setColor(IColor c,
                                  double alpha)

      Overrides:
        `setColor` in class `IObject`

    - #### setColor

          public IVolume setColor(java.awt.Color c)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IVolume setColor(java.awt.Color c,
                                  int alpha)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IVolume setColor(java.awt.Color c,
                                  float alpha)

      Overrides:
        `setColor` in class `IObject`

    - #### setColor

          public IVolume setColor(java.awt.Color c,
                                  double alpha)

      Overrides:
        `setColor` in class `IObject`

    - #### setColor

          public IVolume setColor(int gray)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IVolume setColor(float fgray)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IVolume setColor(double dgray)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IVolume setColor(int gray,
                                  int alpha)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IVolume setColor(float fgray,
                                  float falpha)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IVolume setColor(double dgray,
                                  double dalpha)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IVolume setColor(int r,
                                  int g,
                                  int b)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IVolume setColor(float fr,
                                  float fg,
                                  float fb)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IVolume setColor(double dr,
                                  double dg,
                                  double db)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IVolume setColor(int r,
                                  int g,
                                  int b,
                                  int a)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IVolume setColor(float fr,
                                  float fg,
                                  float fb,
                                  float fa)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IVolume setColor(double dr,
                                  double dg,
                                  double db,
                                  double da)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setHSBColor

          public IVolume setHSBColor(float h,
                                     float s,
                                     float b,
                                     float a)

      Overrides:
        `setHSBColor` in class `IGeometry`

    - #### setHSBColor

          public IVolume setHSBColor(double h,
                                     double s,
                                     double b,
                                     double a)

      Overrides:
        `setHSBColor` in class `IGeometry`

    - #### setHSBColor

          public IVolume setHSBColor(float h,
                                     float s,
                                     float b)

      Overrides:
        `setHSBColor` in class `IGeometry`

    - #### setHSBColor

          public IVolume setHSBColor(double h,
                                     double s,
                                     double b)

      Overrides:
        `setHSBColor` in class `IGeometry`

    - #### weight

          public IVolume weight(double w)

      Overrides:
        `weight` in class `IGeometry`

    - #### weight

          public IVolume weight(float w)

      Overrides:
        `weight` in class `IGeometry`